<?php

if (!defined('IN_MYSPAM')) {
    global $spam_url;
    header('Location: '.$spam_url);
    exit;
}

function CheckFilter($user, $aHeader)
{
    global $dbhost, $dbuser, $dbpass, $dbname;
    global $test_mode;

    try {
        $conn = new PDO('mysql:host='.$dbhost.';dbname='.$dbname, $dbuser, $dbpass);
    } catch (Exception $e) {
        writelog("failed to connect database!");
        return false;
    }
    $conn->query("SET NAMES '".DB_ENCODING."'");

    $aFilter = array();
    $sql = "select filter_id, filter_subject
            from myspam_filter
            where filter_user = ".$conn->quote($user)."
            and filter_enable = 1
            order by 1";
    $stid = $conn->query($sql);
    if (is_object($stid)) {
        while ($row = $stid->fetch()) {
            $aFilter[] = array('id' => $row[0], 'subject' => trim($row[1]));
        }
        $stid = null;
    }

    if ($test_mode) writelog(var_export($aFilter, true));

    $cnt = count($aHeader);
    foreach ($aFilter as $filter) {
        $id = $filter['id'];
        $subject = $filter['subject'];
        $filter_match = 0;
        $filter_not_match = 0;
        $sql = "select rule_header, rule_header_text, rule_condition, rule_text
                from myspam_filter_rule
                where rule_filter_id = $id
                order by rule_id";
        $stid = $conn->query($sql);
        if (is_object($stid)) {
            while ($row = $stid->fetch()) {
                $rule_header = $row[0];
                $rule_header_text = trim($row[1]);
                $rule_condition = $row[2];
                $rule_text = trim($row[3]);

                if ($test_mode) writelog(var_export($row, true));

                $match = 0;
                $not_match = 0;
                switch ($rule_header) {
                    case 0: // other
                        // already in header_text
                        break;

                    case 1: // from
                        $rule_header_text = 'From';
                        break;

                    case 2: // to
                        $rule_header_text = 'To';
                        break;

                    case 3: // cc
                        $rule_header_text = 'Cc';
                        break;

                    case 4: // subject
                        $rule_header_text = 'Subject';
                        break;
                }

                // skip if no header
                if ($rule_header_text == '') continue;

                switch ($rule_condition) {
                    case 0: // ==
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                if (@strcasecmp($aHeader[$i]['value'], $rule_text) == 0) {
                                    $x++;
                                }
                                else {
                                    $not_match++;
                                    break;
                                }
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 1: // !=
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                if (@strcasecmp($aHeader[$i]['value'], $rule_text) == 0) {
                                    $not_match++;
                                    break;
                                }
                                else {
                                    $x++;
                                }
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 2: // in
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                if (@stristr($aHeader[$i]['value'], $rule_text)) {
                                    $x++;
                                }
                                else {
                                    $not_match++;
                                    break;
                                }
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 3: // not in
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                if (@stristr($aHeader[$i]['value'], $rule_text)) {
                                    $not_match++;
                                    break;
                                }
                                else {
                                    $x++;
                                }
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 4: // exist
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                $x++;
                                break;
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 5: // not exist
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                $x++;
                                break;
                            }
                        }
                        if ($x > 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 6: // match preg
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                if (@preg_match($rule_text, $aHeader[$i]['value'])) {
                                    $x++;
                                }
                                else {
                                    $not_match++;
                                    break;
                                }
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;

                    case 7: // not match preg
                        $x = 0;
                        for ($i = 0; $i < $cnt; $i++) {
                            if (strcasecmp($aHeader[$i]['name'], $rule_header_text) == 0) {
                                if (@preg_match($rule_text, $aHeader[$i]['value'])) {
                                    $not_match++;
                                    break;
                                }
                                else {
                                    $x++;
                                }
                            }
                        }
                        if ($x == 0)
                            $not_match++;
                        else
                            $match++;
                        break;
                }
                if ($not_match > 0 || $match == 0)
                    $filter_not_match++;
                else
                    $filter_match++;
            }
            $stid = null;
        }
        if ($filter_not_match == 0 && $filter_match > 0) {
            // match filter
            $conn = null;
            writelog("match filter ($id) $subject for $user");
            return $id.' - '.$subject;
        }
    }

    $conn = null;
    return false;
}

