<?php

if (!defined('IN_MYSPAM')) {
    global $spam_url;
    header('Location: '.$spam_url);
    exit;
}

function ShowFilter($start, $msg = '')
{
    global $smarty, $lang;
    global $dbhost, $dbuser, $dbpass, $dbname;
    global $pagesize;

    if (isset($_SESSION['in_rule'])) {
        if (isset($_POST['back_filter'])) {
            unset($_SESSION['in_rule']);
        }
        else {
            require_once('rule.php');
            ShowRule();
            closelog();
            exit;
        }
    }

    //echo "<!--\n".var_export($_POST, true)."\n-->";
    $username = $_SESSION['username'];
    if (isset($_POST['filter_add']) && $_POST['filter_add']) {
        $subject = trim($_POST['filter_add_subject1']);
        if ($subject == '')
            $subject = trim($_POST['filter_add_subject2']);
        if ($subject != '') {
            try {
                $conn = new PDO('mysql:host='.$dbhost.';dbname='.$dbname, $dbuser, $dbpass);
            } catch (Exception $e) {
                $conn = false;
            }
            if (is_object($conn)) {
                $conn->query("SET NAMES '".DB_ENCODING."'");
                $sql = "select count(*)
                        from myspam_filter
                        where filter_user = ".$conn->quote($username)."
                        and filter_subject = ".$conn->quote($subject);
                $stid = $conn->query($sql);
                if (!is_object($stid)) {
                    syslog(LOG_INFO, "failed to select filter data to mysql");
                    $msg = $lang['DB_ERROR'];
                }
                else {
                    $row = $stid->fetch();
                    $stid = null;
                    if ($row[0] > 0) {
                        $msg = sprintf($lang['FILTER_EXIST'], $subject);
                    }
                    else {
                        $sql = "insert into myspam_filter (
                            filter_user,
                            filter_subject,
                            filter_enable
                        ) values (
                            ".$conn->quote($username).",
                            ".$conn->quote($subject).",
                            0
                        )";
                        if (!$conn->query($sql)) {
                            syslog(LOG_INFO, "failed to insert data to mysql");
                            $msg = $lang['DB_ERROR'];
                        }
                        else {
                            $id = $conn->lastInsertId();
                            $conn = null;
                            require_once('rule.php');
                            $_SESSION['in_rule'] = $id;
                            ShowRule();
                            return;
                        }
                    }
                }
                $conn = null;
            }
            else {
                $msg = $lang['DB_ERROR'];
            }
        }
        else {
            $msg = $lang['FILTER_SUBJECT_EMPTY'];
        }
    }

    if (isset($_POST['delete_yes'])) {
        if (isset($_POST['delete_type']) && $_POST['delete_type'] == 'filter') {
            $id = $_POST['delete_id'];
            if ($id != '') {
                try {
                    $conn = new PDO('mysql:host='.$dbhost.';dbname='.$dbname, $dbuser, $dbpass);
                } catch (Exception $e) {
                    $conn = false;
                }
                if (is_object($conn)) {
                    $conn->query("SET NAMES '".DB_ENCODING."'");
                    $sql = "delete
                            from myspam_filter_rule
                            where rule_filter_id = $id";
                    $stid = $conn->query($sql);
                    if (!is_object($stid)) {
                        syslog(LOG_INFO, "failed to delete rule data to mysql");
                        $msg = $lang['DB_ERROR'];
                    }
                    $sql = "delete
                            from myspam_filter
                            where filter_user = ".$conn->quote($username)."
                            and filter_id = $id";
                    if (!$conn->query($sql)) {
                        syslog(LOG_INFO, "failed to delete filter data to mysql");
                        $msg = $lang['DB_ERROR'];
                    }
                    $conn = null;
                }
                else {
                    $msg = $lang['DB_ERROR'];
                }
            }
        }
    }

    $do = 0;
    $dofilter = '';
    $action = '';
    $id = '';
    foreach ($_POST as $key => $value) {
	$aCmd = explode('_', $key);
        $cnt = count($aCmd);
        if ($cnt > 0)
            $dofilter = $aCmd[0];
        if ($cnt > 1)
            $action = $aCmd[1];
        if ($cnt > 2)
            $id = $aCmd[2];
        if ($dofilter == 'dofilter') {
            $do = 1;
            break;
        }
    }

    if ($do) {
        switch ($action) {
            case 'enable':
                if (isset($_POST['dofilter_enable_'.$id]) && $_POST['dofilter_enable_'.$id] == $lang['FILTER_ENABLE'])
                    $enable = 1;
                else
                    $enable = 0;
                try {
                    $conn = new PDO('mysql:host='.$dbhost.';dbname='.$dbname, $dbuser, $dbpass);
                } catch (Exception $e) {
                    $conn = false;
                }
                if (is_object($conn)) {
                    $conn->query("SET NAMES '".DB_ENCODING."'");
                    $sql = "update myspam_filter set
                                filter_enable = $enable
                            where filter_user = ".$conn->quote($username)."
                            and filter_id = $id";
                    $stid = $conn->query($sql);
                    if (!is_object($stid)) {
                        syslog(LOG_INFO, "failed to update filter data to mysql");
                        $msg = $lang['DB_ERROR'];
                    }
                    $conn = null;
                }
                else {
                    $msg = $lang['DB_ERROR'];
                }
                break;

            case 'delete':
                $question = $lang['CONFIRM_QUESTION'].'<br />'.
                            $lang['FILTER_ID'].': '.$id;
                $smarty->assign(array(
                        'ENCODING' => ENCODING,
                        'MYSPAM_VER' => MYSPAM_VER,
                        'HELP_LINK' => HELP_LINK,
                        'HELP_DESC' => $lang['HELP_DESC'],
                        'LANG' => $lang['LANG'],
                        'TITLE' => $lang['TITLE'].' - FILTER',
                        'CONFIRM_TITLE' => sprintf($lang['FILTER_TITLE'], $username),
                        'CONFIRM_QUESTION' => $question,
                        'DELETE_TYPE' => 'filter',
                        'DELETE_ID' => $id,
                        'DELETE_YES' => $lang['DELETE_YES'],
                        'DELETE_NO' => $lang['DELETE_NO']
                        ));
                $smarty->display('confirm_delete.tpl');
                return;

            case 'edit':
                require_once('rule.php');
                $_SESSION['in_rule'] = $id;
                ShowRule();
                return;
        }
    }

    $smarty->assign(array(
            'ENCODING' => ENCODING,
            'MYSPAM_VER' => MYSPAM_VER,
            'HELP_LINK' => HELP_LINK,
            'HELP_DESC' => $lang['HELP_DESC'],
            'LANG' => $lang['LANG'],
            'TITLE' => $lang['TITLE'].' - FILTER',
            'FILTER_TITLE' => sprintf($lang['FILTER_TITLE'], $username),
            'FILTER_ID' => $lang['FILTER_ID'],
            'FILTER_SUBJECT' => $lang['FILTER_SUBJECT'],
            'FILTER_ENABLE' => $lang['FILTER_STATUS'],
            'FILTER_EDIT' => $lang['FILTER_EDIT'],
            'FILTER_DELETE' => $lang['FILTER_DELETE'],
            'FILTER_ADD' => $lang['FILTER_ADD'],
            'FILTER_BACKLIST' => $lang['FILTER_BACKLIST'],
            'FILTER_LOGOUT' => $lang['FILTER_LOGOUT']
            ));

    if ($msg != '') {
        $smarty->assign(array(
                'ERROR_MESSAGE' => $msg,
                'ERROR_BEGIN' => '',
                'ERROR_END' => '',
                ));
    }
    else {
        $smarty->assign(array(
                'ERROR_MESSAGE' => '',
                'ERROR_BEGIN' => '<!--',
                'ERROR_END' => '-->',
                ));
    }

    $total = 0;
    $aData = array();
    try {
        $conn = new PDO('mysql:host='.$dbhost.';dbname='.$dbname, $dbuser, $dbpass);
    } catch (Exception $e) {
        $conn = false;
    }
    if (is_object($conn)) {
        $conn->query("SET NAMES '".DB_ENCODING."'");

        $sql = "select count(*)
                from myspam_filter
                where filter_user = ".$conn->quote($username);
        $stid = $conn->query($sql);
        if (is_object($stid)) {
            $row = $stid->fetch();
            $total = $row[0];
            $stid = null;
        }
    }
    else
        $total = 0;

    if (($start+1) > $total) {
        $start = floor(($total-1)/$pagesize);
        if ($start < 0) $start = 0;
    }

    if ($total > 0) {
        $sql = "select filter_id, filter_subject, filter_enable
                from myspam_filter
                where filter_user = ".$conn->quote($username)."
                order by 1
                limit $start, $pagesize";
        $stid = $conn->query($sql);
        if (is_object($stid)) {
            $row_num = 0;
            while ($row = $stid->fetch()) {
                $aData[] = array('filter_id' => $row[0],
                                 'subject' => htmlspecialchars($row[1]),
                                 'class' => $row_num++ % 2 == 0 ? 'row2' : 'row1',
                                 'do_enable' => htmlspecialchars($row[2] == 0 ? $lang['FILTER_ENABLE'] : $lang['FILTER_DISABLE']),
                                 'enable' => htmlspecialchars($row[2] == 0 ? $lang['FILTER_DISABLE'] : $lang['FILTER_ENABLE']));
            }
            $stid = null;
        }
    }
    $smarty->assign('data', $aData);
    $conn = null;

    $cur_page = floor($start/$pagesize) + 1;
    $totalpage = ceil($total/$pagesize);
    if ($cur_page < 1) $cur_page = 1;
    if ($totalpage < 1) $totalpage = 1;
    $smarty->assign('PAGE_LEFT', sprintf($lang['PAGE_OF'], $cur_page, $totalpage, $total));

    $msg = $lang['PAGE_GOTO'];
    if ($cur_page != 1) {
        $pagestart = $start - $pagesize;
        $msg .= " <a href=\"?start=$pagestart\">".$lang['PAGE_PREV']."</a>";
    }
    $last_page = 1;
    for ($i = 1; $i <= 3; $i++) {
        if ($i > $totalpage) break;
        if ($i != 1)
            $msg .= ',';
        if ($i == $cur_page) {
            $msg .= " $i";
        }
        else {
            $pagestart = ($i-1) * $pagesize;
            $msg .= " <a href=\"?start=$pagestart\">$i</a>";
        }
        $last_page = $i;
    }
    $prevpage = $cur_page - 1;
    if ($prevpage <= 3)
        $prevpage = 4;
    $nextpage = $cur_page + 1;
    if ($nextpage > $totalpage)
        $nextpage = $totalpage;
    $jump = 0;
    if ($prevpage > 4) {
        $msg .= " ... ";
        $jump = 1;
    }
    for ($i = $prevpage; $i <= $nextpage; $i++) {
        if ($i > $totalpage) break;
        if ($i != 1 && $jump == 0)
            $msg .= ',';
        $jump = 0;
        if ($i == $cur_page) {
            $msg .= " $i";
        }
        else {
            $pagestart = ($i-1) * $pagesize;
            $msg .= " <a href=\"?start=$pagestart\">$i</a>";
        }
        $last_page = $i;
    }
    $prevpage = $totalpage - 2;
    if ($prevpage <= $last_page)
        $prevpage = $last_page+1;
    $jump = 0;
    if ($prevpage != ($last_page+1)) {
        $msg .= " ... ";
        $jump = 1;
    }
    for ($i = $prevpage; $i <= $totalpage; $i++) {
        if ($i > $totalpage) break;
        if ($i != 1 && $jump == 0)
            $msg .= ',';
        $jump = 0;
        if ($i == $cur_page) {
            $msg .= " $i";
        }
        else {
            $pagestart = ($i-1) * $pagesize;
            $msg .= " <a href=\"?start=$pagestart\">$i</a>";
        }
        $last_page = $i;
    }
    if ($cur_page != $totalpage) {
        $pagestart = $start + $pagesize;
        $msg .= " <a href=\"?start=$pagestart\">".$lang['PAGE_NEXT']."</a>";
    }

    $smarty->assign('PAGE_RIGHT', $msg);

    $smarty->display('filter.tpl');
    return;
}

