<?php

if (!defined('IN_MYSPAM')) {
    global $spam_url;
    header('Location: '.$spam_url);
    exit;
}

function SendNotify()
{
    global $smarty, $lang;
    global $dbhost, $dbuser, $dbpass, $dbname;
    global $mydomain;
    global $spam_url;
    global $keep_days;
    global $debug;

    $log_level = $debug ? LOG_DEBUG : LOG_INFO;
    $aUser = array();
    try {
        $conn = new PDO('mysql:host='.$dbhost.';dbname='.$dbname, $dbuser, $dbpass);
    } catch (Exception $e) {
        syslog($log_level, "notify: can't connect to database!");
        return;
    }
    $conn->query("SET NAMES '".DB_ENCODING."'");

    $sql = "select email_user
            from myspam_email
            where email_notify = 0
            group by 1";
    $stid = $conn->query($sql);
    if (is_object($stid)) {
        while ($row = $stid->fetch()) {
            $aUser[] = $row[0];
        }
        $stid = null;
    }

    foreach ($aUser as $user) {
        $aData = array();
        $list = '';
        $sql = "select email_id, email_from, email_subject, email_time, email_size
                from myspam_email
                where email_user = ".$conn->quote($user)."
                and email_notify = 0
                order by email_time desc";
        $stid = $conn->query($sql);
        if (is_object($stid)) {
            $row_num = 0;
            while ($row = $stid->fetch()) {
                if ($list == '')
                    $list = $row[0];
                else
                    $list .= ','.$row[0];
                $aData[] = array('from' => htmlspecialchars($row[1]),
                                 'subject' => htmlspecialchars($row[2]),
                                 'date' => htmlspecialchars($row[3]),
                                 'class' => $row_num++ % 2 == 0 ? 'row2' : 'row1',
                                 'size' => $row[4]);
            }
            $stid = null;
        }
        $cnt = count($aData);
        if ($cnt > 0) {
            $smarty->clearAllAssign();
            $smarty->assign(array(
                    'ENCODING' => ENCODING,
                    'MYSPAM_VER' => MYSPAM_VER,
                    'HELP_LINK' => $spam_url.'/'.HELP_LINK,
                    'HELP_DESC' => $lang['HELP_DESC'],
                    'LANG' => $lang['LANG'],
                    'TITLE' => $lang['TITLE'],
                    'LIST_TITLE' => sprintf($lang['LIST_TITLE'], $user),
                    'HEAD_SUBJECT' => $lang['HEAD_SUBJECT'],
                    'HEAD_FROM' => $lang['HEAD_FROM'],
                    'HEAD_DATE' => $lang['HEAD_DATE'],
                    'HEAD_SIZE' => $lang['HEAD_SIZE'],
                    'PAGE_RIGHT' => sprintf($lang['NOTIFY_COUNT'], $cnt),
                    'NOTIFY_HELP' => sprintf($lang['NOTIFY_HELP'], $keep_days),
                    'NOTIFY_URL' => $spam_url,
                    'data' => $aData
                    ));
            $message = $smarty->fetch('notify.tpl');
            if (strstr($user, '@'))
                $to = $user;
            else
                $to = "$user@$mydomain";
            $subject = "=?".ENCODING."?B?".base64_encode(sprintf($lang['NOTIFY_SUBJECT'], $user))."?=";
            $header = "From: $to\r\n".
                      "X-MySPAM: YES\r\n".
                      "Content-Type: text/html; charset=\"".ENCODING."\"";
            if (@mail($to, $subject, $message, $header)) {
                syslog($log_level, "send notify to $user ($cnt)");
                if ($list != '') {
                    $sql = "update myspam_email set
                                email_notify = 1,
                                email_time = email_time
                            where email_user = ".$conn->quote($user)."
                            and email_id in ($list)";
                    $conn->query($sql);
                }
            }
            else {
                syslog($log_level, "failed to send notify to $user");
            }
        }
    }

    $sql = "delete
            from myspam_email
            where email_time < subdate(now(), $keep_days)";
    $stid = $conn->query($sql);
    if (is_object($stid)) {
        $cnt = $stid->rowCount();
        $stid = null;
    }
    syslog($log_level, "delete $cnt email for older than $keep_days days");

    $sql = "delete
            from myspam_filter_email
            where filter_email_time < subdate(now(), $keep_days)";
    $stid = $conn->query($sql);
    if (is_object($stid)) {
        $cnt = $stid->rowCount();
        $stid = null;
    }
    syslog($log_level, "delete $cnt filter record for older than $keep_days days");

    $conn = null;
    return;
}

